/**
 * Copyright IBM Corp. 2016, 2018
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import React from 'react';
import { NotificationActionButton as NotificationActionButtonNext, NotificationButton as NotificationButtonNext, ToastNotification as ToastNotificationNext, InlineNotification as InlineNotificationNext } from './next/Notification';
import { NotificationActionButton as NotificationActionButtonClassic, NotificationTextDetails as NotificationTextDetailsClassic, NotificationButton as NotificationButtonClassic, ToastNotification as ToastNotificationClassic, InlineNotification as InlineNotificationClassic } from './Notification';
import { useFeatureFlag } from '../FeatureFlags';
export function NotificationActionButton(props) {
  var enabled = useFeatureFlag('enable-v11-release');

  if (enabled) {
    return /*#__PURE__*/React.createElement(NotificationActionButtonNext, props);
  }

  return /*#__PURE__*/React.createElement(NotificationActionButtonClassic, props);
}
export function NotificationTextDetails(props) {
  var enabled = useFeatureFlag('enable-v11-release');

  if (enabled) {
    return null;
  }

  return /*#__PURE__*/React.createElement(NotificationTextDetailsClassic, props);
}
export function NotificationButton(props) {
  var enabled = useFeatureFlag('enable-v11-release');

  if (enabled) {
    return /*#__PURE__*/React.createElement(NotificationButtonNext, props);
  }

  return /*#__PURE__*/React.createElement(NotificationButtonClassic, props);
}
export function ToastNotification(props) {
  var enabled = useFeatureFlag('enable-v11-release');

  if (enabled) {
    return /*#__PURE__*/React.createElement(ToastNotificationNext, props);
  }

  return /*#__PURE__*/React.createElement(ToastNotificationClassic, props);
}
export function InlineNotification(props) {
  var enabled = useFeatureFlag('enable-v11-release');

  if (enabled) {
    return /*#__PURE__*/React.createElement(InlineNotificationNext, props);
  }

  return /*#__PURE__*/React.createElement(InlineNotificationClassic, props);
}